summaryrefslogtreecommitdiffstats
path: root/multimedia/mlt/mlt.SlackBuild
blob: e5f88343b28eea915a60e7761d4c1a953d809a3c (plain)
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
#!/bin/sh

# Slackware build script for mlt.

# Written by stormtracknole - stormtracknole@gmail.com

# Modified by Erik Hanson (erik@slackbuilds.org) with
# help from Jonathan Larsen (agentc0re@learnix.net)
#
# Feb 16, 2010 - Modified the script and defined the $PYTHON variable
#	outside of the if statement because it was causing issues with
#	the other if statement that also relies on it's answer.
#	- Fixed the second PYTHON if statement that finds the site package
#	directory.  Added parentheses around the part that cd's into the
#	python swig src to copy the files to the site packages so that it
#	would interfere with the CWD before it
#
# +---------------------------------------+
# Mar 3rd, 2010
#   *Version upgrade to 0.5.2
#	*fixed the "strip" for bash 4
#	 compatability
# +---------------------------------------+
# Sept 12, 2010
#	*Version upgrade to 0.5.6
#	*Bug fixes and enhancements added
# +---------------------------------------+
# May 16, 2011
#	*Version upgrade to 0.7.2
# +---------------------------------------+
# Dec 14, 2011
#	*Version upgrade to 0.7.6
#	*Bug fixes
# +---------------------------------------+
# Jul 2, 2012
#	*Version upgrade to 0.8.0
#	*Bug fixes
# +---------------------------------------+
# Apr 2, 2013
#	*Version upgrade to 0.8.8
#	*Added frei0r as a dependency
# +---------------------------------------+
# Jun 9, 2015
#	*Version upgrade to 0.9.6
#	*Fixed lua portion of the code
#	 thanks to John Vogel.
# +---------------------------------------+
# 20-MAR-2016	new maintainer, version update to 6.0.0
# 11-OCT-2016	version update
# 22-OCT-2016   add qt5 support, bug fixes/addenda (Larry Hajali)

PRGNAM=mlt
VERSION=${VERSION:-6.2.0}
BUILD=${BUILD:-3}
TAG=${TAG:-_SBo}

if [ -z "$ARCH" ]; then
  case "$( uname -m )" in
    i?86) ARCH=i586 ;;
    arm*) ARCH=arm ;;
       *) ARCH=$( uname -m ) ;;
  esac
fi

CWD=$(pwd)
TMP=${TMP:-/tmp/SBo}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}

# Autodetect which SWIG Languages bindings to build
# according to what's installed on the system:
if [ -f "$(which javac)" ]; then java="java"; else java=""; fi
if [ -f "$(which lua)" ]; then lua="lua"; else lua=""; fi
if [ -f "$(which perl)" ]; then perl="perl"; else perl=""; fi
if [ -f "$(which php)" ]; then php="php"; else php=""; fi
if [ -f "$(which python)" ]; then python="python"; else python=""; fi
if [ -h "$(which tclsh)" ]; then tcl="tcl"; else tcl=""; fi
if [ -f "$(which csharp)" ]; then csharp="csharp"; else csharp=""; fi
if [ -f "$(which ruby)" ]; then ruby="ruby"; else ruby=""; fi

if pkg-config --exists vdpau ; then vdpau="--avformat-vdpau" ; else vdpau="" ; fi

# Use qt5 if present, otherwise system default
if pkg-config --exists Qt5 ; then
  qt="--qt-libdir=$(pkg-config Qt5 --variable=libdir)
      --qt-includedir=$(pkg-config Qt5 --variable=headerdir)"
else
  qt="--qt-libdir=$(pkg-config Qt --variable=libdir)
      --qt-includedir=$(pkg-config Qt --variable=headerdir)"
fi

if [ "$ARCH" = "i586" ]; then
  SLKCFLAGS="-O2 -march=i586 -mtune=i686"
  LIBDIRSUFFIX=""
elif [ "$ARCH" = "i686" ]; then
  SLKCFLAGS="-O2 -march=i686 -mtune=i686"
  LIBDIRSUFFIX=""
elif [ "$ARCH" = "x86_64" ]; then
  SLKCFLAGS="-O2 -fPIC"
  LIBDIRSUFFIX="64"
else
  SLKCFLAGS="-O2"
  LIBDIRSUFFIX=""
fi

set -e

rm -rf $PKG
mkdir -p $TMP $PKG $OUTPUT
cd $TMP
rm -rf $PRGNAM-$VERSION
tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
cd $PRGNAM-$VERSION
chown -R root:root .
find -L . \
 \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
  -o -perm 511 \) -exec chmod 755 {} \; -o \
 \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
  -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;

# Fix building against qt >= 5.7.
patch -p1 < $CWD/qt5-5.7.patch

CFLAGS="$SLKCFLAGS" \
CXXFLAGS="$SLKCFLAGS" \
./configure \
  --disable-debug \
  --prefix=/usr \
  --libdir=/usr/lib${LIBDIRSUFFIX} \
  --enable-gpl \
  --enable-gpl3 \
  --luma-compress \
  --enable-motion-est \
  $vdpau \
  $qt \
  --swig-languages="$java $lua $perl $php $python $ruby $tcl $csharp" \
  --build=$ARCH-slackware-linux

make clean
CFLAGS="$SLKCFLAGS" CXXFLAGS="$SLKCFLAGS" make
make install DESTDIR=$PKG

# Install built bindings
if [ "$lua" ]; then
  ( cd $TMP/$PRGNAM-$VERSION/src/swig/lua
    install -D -m 0755 mlt.so $PKG/$(pkg-config --variable INSTALL_CMOD lua)/mlt.so
    install -D -m 0644 play.lua $PKG/usr/doc/$PRGNAM-$VERSION/play.lua
  )
fi
if [ "$perl" ]; then
  ( cd $TMP/$PRGNAM-$VERSION/src/swig/perl
    install -D -m 0644 mlt.pm $PKG/usr/share/perl5/mlt.pm
    install -D -m 0755 play.pl $PKG/usr/share/perl5/play.pl
    install -D -m 0755 blib/arch/auto/mlt/mlt.so \
      $PKG/usr/lib$LIBDIRSUFFIX/perl5/auto/mlt/mlt.so
    install -D -m 0644 mlt.bs \
      $PKG/usr/lib$LIBDIRSUFFIX/perl5/auto/mlt/mlt.bs
  )
fi
if [ "$php" ]; then
  ( cd $TMP/$PRGNAM-$VERSION/src/swig/php
    install -D -m 0755 mlt.so $PKG/usr/lib$LIBDIRSUFFIX/php/extensions/mlt.so
    install -D -m 0644 play.php $PKG/usr/doc/$PRGNAM-$VERSION/play.php
    mkdir -p $PKG/etc/php.d
    cat > $PKG/etc/php.d/$PRGNAM.ini.new << EOF
; Enable mlt extension module
; extension=$PRGNAM.so
EOF
  )
fi
if [ "$python" ]; then
  PYTHONSITEPKG=$(python -c "import sys, os; print os.path.join('/usr/lib${LIBDIRSUFFIX}', 'python%s' % sys.version[:3], 'site-packages')")
  ( cd $TMP/$PRGNAM-$VERSION/src/swig/python
    install -D -m 0755 _mlt.so $PKG/$PYTHONSITEPKG/_mlt.so
    install -D -m 0755 mlt.py $PKG/$PYTHONSITEPKG/mlt.py
    install -D -m 0755 play.py $PKG/usr/doc/$PRGNAM-$VERSION/play.py
  )
fi
if [ "$ruby" ]; then
  ( cd $TMP/$PRGNAM-$VERSION/src/swig/ruby
    install -D -m 0755 mlt.so \
      $PKG$(ruby -e 'print RbConfig::CONFIG["sitearchdir"]')/mlt.so
    install -D -m 0755 play.rb $PKG/usr/doc/$PRGNAM-$VERSION/play.rb
    install -D -m 0755 thumbs.rb $PKG/usr/doc/$PRGNAM-$VERSION/thumbs.rb
  )
fi
if [ "$tcl" ]; then
  ( cd $TMP/$PRGNAM-$VERSION/src/swig/tcl
    . /usr/lib$LIBDIRSUFFIX/tclConfig.sh
    install -D -m 0755 mlt.so \
      $PKG/usr/lib$LIBDIRSUFFIX/tcl$TCL_MAJOR_VERSION/$TCL_VERSION/mlt.so
    install -D -m 0755 play.tcl $PKG/usr/doc/$PRGNAM-$VERSION/play.tcl
  )
fi

# todo: java, csharp

find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
  | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true

mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cp -a AUTHORS ChangeLog NEWS COPYING README GPL $PKG/usr/doc/$PRGNAM-$VERSION
cat src/modules/motion_est/README > $PKG/usr/doc/$PRGNAM-$VERSION/README.motion_est
cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild

mkdir -p $PKG/install
cat $CWD/slack-desc > $PKG/install/slack-desc
cat $CWD/doinst.sh > $PKG/install/doinst.sh

if [ "$php" ]; then
  echo "config etc/php.d/$PRGNAM.ini.new" >> $PKG/install/doinst.sh
fi

cd $PKG
/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}